'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.default = {
  rxdb: true,
  prototypes: {
    RxDatabase: function RxDatabase(proto) {
      var prevCollection = proto.collection;
      Object.assign(proto, {
        collection: function () {
          var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(model) {
            for (var _len = arguments.length, other = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
              other[_key - 1] = arguments[_key];
            }

            var timestamps, collection;
            return regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    timestamps = model && model.options && model.options.timestamps;
                    _context.next = 3;
                    return prevCollection.call(this, model, other);

                  case 3:
                    collection = _context.sent;

                    if (timestamps) {
                      _context.next = 6;
                      break;
                    }

                    return _context.abrupt('return', collection);

                  case 6:

                    // Register hooks
                    collection.preInsert(function (doc) {
                      var now = new Date().toISOString();
                      if (!doc.createdAt) doc.createdAt = now;
                      if (!doc.updatedAt) doc.updatedAt = now;

                      return doc;
                    });

                    collection.preSave(function (doc) {
                      if (!doc.updatedAt) doc.updatedAt = new Date().toISOString();
                      return doc;
                    });

                    return _context.abrupt('return', collection);

                  case 9:
                  case 'end':
                    return _context.stop();
                }
              }
            }, _callee, this);
          }));

          function collection(_x) {
            return _ref.apply(this, arguments);
          }

          return collection;
        }()
      });
    }
  },
  overwritable: {},
  hooks: {
    preCreateRxCollection: function preCreateRxCollection() {
      var model = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var timestamps = model && model.options && model.options.timestamps;
      if (!timestamps) return model;

      // Set schema

      return Object.assign({}, model, {
        schema: Object.assign({}, model.schema || {}, {
          properties: Object.assign({
            createdAt: {
              format: 'date-time',
              type: 'string'
            },
            updatedAt: {
              format: 'date-time',
              type: 'string'
            }
          }, model.schema && model.schema.properties || {}),
          required: [].concat(_toConsumableArray(model.schema && model.schema.required || []), ['createdAt', 'updatedAt'])
        })
      });
    }
  }
};